/**
 * @file
 * VuoList_VuoSyphonServerDescription C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoSyphonServerDescription_H
#define VuoList_VuoSyphonServerDescription_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoSyphonServerDescription VuoList_VuoSyphonServerDescription
 * A list of @ref VuoSyphonServerDescription elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoSyphonServerDescription_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoSyphonServerDescription elements.
 */
typedef const struct VuoList_VuoSyphonServerDescription_struct { void *l; } * VuoList_VuoSyphonServerDescription;
/// @}
#endif

/**
 * Creates a new list of @ref VuoSyphonServerDescription elements.
 */
VuoList_VuoSyphonServerDescription VuoListCreate_VuoSyphonServerDescription(void);

/**
 * Makes a shallow copy of `list` — its items are retained (not copied) by the new list.
 */
VuoList_VuoSyphonServerDescription VuoListCopy_VuoSyphonServerDescription(const VuoList_VuoSyphonServerDescription list);

/**
 * Returns the @ref VuoSyphonServerDescription at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoSyphonServerDescription VuoListGetValue_VuoSyphonServerDescription(const VuoList_VuoSyphonServerDescription list, const unsigned long index);

/**
 * Changes the @ref VuoSyphonServerDescription at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValue_VuoSyphonServerDescription(const VuoList_VuoSyphonServerDescription list, const VuoSyphonServerDescription value, const unsigned long index);

/**
 * Inserts the `VuoSyphonServerDescription` immediately before `index`.
 * Index values start at 1.
 * Inserting at index 0 prepends the value to the list.
 * Inserting at an index beyond the last value in the list appends the value to the list.
 */
void VuoListInsertValue_VuoSyphonServerDescription(const VuoList_VuoSyphonServerDescription list, const VuoSyphonServerDescription value, const unsigned long index);

/**
 * Prepends @c value to @c list.
 */
void VuoListPrependValue_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list, const VuoSyphonServerDescription value);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list, const VuoSyphonServerDescription value);

/**
 * Swaps the value at `indexA` with the value at `indexB`.
 */
void VuoListExchangeValues_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list, const unsigned long indexA, const unsigned long indexB);

/**
 * Generates a random permutation of `list`.
 *
 * `chaos` ranges from 0 to 1.  When `chaos` is 1, a full Fisher–Yates shuffle is performed.  When less than 1, fewer iterations are performed.
 */
void VuoListShuffle_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list, const double chaos);

/**
 * Reverses the order of the items in `list`.
 */
void VuoListReverse_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list);

/**
 * Removes items from the list except those in the range specified by `startIndex` and `itemCount`.
 */
void VuoListCut_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list, const signed long startIndex, const unsigned long itemCount);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list);

/**
 * Removes the `VuoSyphonServerDescription` at `index`.
 * Index values start at 1.
 * Attempting to remove index 0 or an index beyond the last value in the list has no effect.
 */
void VuoListRemoveValue_VuoSyphonServerDescription(VuoList_VuoSyphonServerDescription list, const unsigned long index);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoSyphonServerDescription(const VuoList_VuoSyphonServerDescription list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoSyphonServerDescription VuoList_VuoSyphonServerDescription_makeFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoSyphonServerDescription_getJson(const VuoList_VuoSyphonServerDescription value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoSyphonServerDescription_getSummary(const VuoList_VuoSyphonServerDescription value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoSyphonServerDescription VuoList_VuoSyphonServerDescription_makeFromString(const char *str);
char * VuoList_VuoSyphonServerDescription_getString(const VuoList_VuoSyphonServerDescription value);
/// @}

/**
 * @}
 */

#endif
